package jp.mosp.payroll.base;

import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import jp.mosp.common.common.MospException;
import jp.mosp.express.ExpressUtility;
import jp.mosp.payroll.bonus.dto.PmDetailBsDto;
import jp.mosp.payroll.dto.DetailDto;

/**
 * 給与計算関連伝票の元となるクラス。<br><br>
 */
public abstract class PayrollSlipBonus {
	
	/**
	 * 明細情報を取得する。
	 * @param detailCode 明細コード
	 */
	protected DetailDto getDetailDto(List<?> list, String detailCode) {
		for (Object name : list) {
			DetailDto dto = (DetailDto)name;
			if (dto.getDetailCode().equals(detailCode)) {
				return dto;
			}
		}
		return null;
	}
	
	/**
	 * 明細リストを設定する。
	 * @param aryDetail 設定対象明細配列
	 */
	protected void setDetails(List<?> listDetail, String[][] aryDetail) {
		for (Object name : listDetail) {
			DetailDto dto = (DetailDto)name;
			for (String[] element : aryDetail) {
				if (dto.getDetailCode().equals(element[0])) {
					setDetailAmount(dto, Float.parseFloat(element[2]));
					break;
				}
			}
		}
	}
	
	/**
	 * 明細値を取得する。
	 * @param list 取得対象リスト
	 * @param detailCode 取得対象明細コード
	 * @return 明細値
	 */
	protected float getDetailAmount(List<?> list, String detailCode) {
		for (Object name : list) {
			DetailDto dto = (DetailDto)name;
			if (dto.getDetailCode().equals(detailCode)) {
				if (dto instanceof PmDetailBsDto) {
					PmDetailBsDto detailBsDto = (PmDetailBsDto)dto;
					return detailBsDto.getAmount();
				}
			}
		}
		return 0;
	}
	
	/**
	 * 明細配列を取得する。
	 * @param list             取得対象リスト
	 * @param checkDisplayType 0印字区分確認要否
	 * @return 明細配列
	 */
	protected String[][] getAryDetail(List<?> list, boolean checkDisplayType) {
		String[][] aryDetail = new String[list.size()][3];
		for (int i = 0; i < list.size(); i++) {
			DetailDto dto = (DetailDto)list.get(i);
			aryDetail[i][0] = dto.getDetailCode();
			aryDetail[i][1] = dto.getDetailAbbr();
			aryDetail[i][2] = "0";
			if (dto instanceof PmDetailBsDto) {
				aryDetail[i][2] = String.valueOf(((PmDetailBsDto)dto).getAmount());
			}
			if (checkDisplayType && dto.getDisplayType() == PayrollConst.DETAIL_DISP_NONE) {
				if (String.valueOf(aryDetail[i][2]).equals("0")) {
					aryDetail[i][1] = "";
					aryDetail[i][2] = "";
				}
			}
		}
		return aryDetail;
	}
	
	/**
	 * 明細値を設定する。
	 * @param list       明細情報
	 * @param listAmount 明細値リスト
	 */
	protected void setDetailsAmount(List<?> list, List<?> listAmount) {
		for (Object name : list) {
			DetailDto dto = (DetailDto)name;
			for (Object name2 : listAmount) {
				DetailDto dtoAmount = (DetailDto)name2;
				if (dto.getDetailCode().equals(dtoAmount.getDetailCode())) {
					if (dtoAmount instanceof PmDetailBsDto) {
						setDetailAmount(dto, ((PmDetailBsDto)dtoAmount).getAmount());
						break;
					}
				}
			}
		}
	}
	
	/**
	 * 明細値を計算する。
	 * @param listDetail 明細リスト
	 * @param mapParams  パラメータMap
	 * @throws MospException 
	 */
	protected void calcDetails(List<?> listDetail, Map<String, String> mapParams) throws MospException {
		for (Object name : listDetail) {
			DetailDto dto = (DetailDto)name;
			setDetailAmount(dto, calcExpr(dto.getExpression(), mapParams));
		}
	}
	
	/**
	 * 明細値を計算する。
	 * @param detailDto 明細DTO
	 * @param amount 
	 * @param mapParams パラメータMap
	 */
	protected void setDetailAmount(DetailDto detailDto, float amount) {
		if (detailDto instanceof PmDetailBsDto) {
			PmDetailBsDto dto = (PmDetailBsDto)detailDto;
			dto.setAmount((int)amount);
			return;
		}
		
	}
	
	/**
	 * 明細を初期化する。
	 * @param 初期化対象明細リスト
	 */
	protected void initDetails(List<?> list, String kCode, Date calcDate) {
		for (Object name : list) {
			initDetail((DetailDto)name, kCode, calcDate);
		}
	}
	
	/**
	 * 明細を初期化する。
	 * @param 初期化対象明細
	 */
	private void initDetail(DetailDto dto, String kCode, Date calcDate) {
		dto.setKCode(kCode);
		dto.setCalcDate(calcDate);
		if (dto instanceof PmDetailBsDto) {
			((PmDetailBsDto)dto).setAmount(0);
			return;
		}
	}
	
	/**
	 * 計算式を計算する。<br>
	 * @param expression 計算式
	 * @param mapParams  パラメータ
	 * @return 計算値
	 * @throws MospException MosP例外処理が発生した場合
	 */
	protected float calcExpr(String expression, Map<String, String> mapParams) throws MospException {
		return ExpressUtility.calculate(expression, mapParams, new HashMap<String, String[][]>());
	}
}
